#pragma once

#include <vector>
#include <string>

/**
 * This is a private implementation class for the Vamp Host SDK.
 */
class Files
{
  public:
    static std::vector<std::string> listLibraryFiles();

    struct Filter {
        enum { All, Matching, NotMatching } type;
        std::vector<std::string> libraryNames;
        Filter() : type(All) { }
    };
    static std::vector<std::string> listLibraryFilesMatching(Filter);

    static void *loadLibrary(std::string filename);
    static void unloadLibrary(void *);
    static void *lookupInLibrary(void *, const char *symbol);

    static std::string lcBasename(std::string path);
    static std::string splicePath(std::string a, std::string b);
    static std::vector<std::string> listFiles(std::string dir, std::string ext);

    static bool isNonNative32Bit();
    static bool getEnvUtf8(std::string variable, std::string &value);
};
